
#include <Array.au3>

#cs

transpose words, v.01
Samuel Murray, March 2020

This script cuts the text, splits it by space, then reverses the "word" order, then puts spaces back, and pastes the text.

If you accidentally select a space at the end, the script compensates for it.  The script does not compensate if you accidentally select something else, or if you accidentially do not select an entire word.

Shift + Ctrl + , = reverse words

Examples:
one two = two one
one two three = three two one
one two three four = four three two one

Shift + Ctrl + . = switch first and last words

Examples:
one two = two one
one two three = three two one
one two three four = four two three one

#ce

HotKeySet("^+,", "doreverse1")
HotKeySet("^+.", "doreverse2")

While 1
    Sleep(100)
WEnd

Func doreverse1()

Send ("^x")
Sleep ("200")
$clippy = ClipGet ()
Sleep ("200")

$i = 0
If StringRight ($clippy, 1) = " " Then
$clippy = StringTrimRight ($clippy, 1)
$i = 1
EndIf

$wordsarray = StringSplit ($clippy, " ")

$wordsarray2 = $wordsarray
_ArrayDelete ($wordsarray2, 0)

_ArrayReverse ($wordsarray2)

$newstring = _ArrayToString ($wordsarray2, " ")

If $i = 1 Then
$newstring = $newstring & " "
EndIf

ClipPut ($newstring)
Sleep ("200")
Send ("^v")

EndFunc

Func doreverse2()

Send ("^x")
Sleep ("200")
$clippy = ClipGet ()
Sleep ("200")

$i = 0
If StringRight ($clippy, 1) = " " Then
$clippy = StringTrimRight ($clippy, 1)
$i = 1
EndIf

$wordsarray = StringSplit ($clippy, " ")
$wordsarray2 = $wordsarray
$county = $wordsarray2[0] - 1
_ArrayDelete ($wordsarray2, 0)

_ArraySwap($wordsarray2, 0, $county)

$newstring = _ArrayToString ($wordsarray2, " ")

If $i = 1 Then
$newstring = $newstring & " "
EndIf

ClipPut ($newstring)
Sleep ("200")
Send ("^v")

EndFunc
